<template>
    <b-modal v-model="modalVisible" class="modal-primary" ref="paymentModalRef" size="lg" title="Phiếu thu tiền">
            <div class="modal-body" v-if="Object.keys(agency).length >2">
                <span class="text-info col-form-label py-6">Thông tin đại lý: </span>
                <div class="row">
                    
                    <div class="col-md-6 col-xs-12">
                        <div class="row">
                         <label for="agency-name" class="col-md-3">Tên đại lý:</label>
                  <span id="agency-name" class="font-weight-bold col-md-9">{{ agency.name }}</span>
                        </div>
                    </div>
               <div class="col-md-6 col-xs-12">
   <div class="row">
                    <label for="address" class="col-md-3">Địa chỉ:</label>
                    <span id="address" class="font-weight-bold col-md-9">{{ fullAdress }}</span>
                </div>
               </div>
                </div>

             
                <span for="address" class="text-info py-6">Người thanh toán: </span>
                <div class="row">
                    <div class="col-md-6 col-xs-12">
                <div class="row">
                        <label for="customer_name" class="col-md-3">Họ và tên:</label>
                        <span id="customer_name" class="font-weight-bold col-md-9">{{ agency.owner.fullname }}</span>
                </div>
                </div>
                 <div class="col-md-6 col-xs-12">
                <div class="row">
                    <label for="phone_number" class="col-md-3">SĐT:</label>
                    <span id="phone_number" class="font-weight-bold col-md-9">{{ agency.owner.phone_number }}</span>
                        <div v-if="Object.keys(agency.customers).length > 1">
                <div class="form-group" id="changeCustomerContainer" v-if="customerOptionVisibility" >
                    <div class="col-md-6"> <select class="form-control" id="selectCustomer" >
                        
                        </select></div>
                    <div class="col-md-6"><button type="button" id="confirmCustomerSelection" class="btn btn-success">Xác nhận</button></div>
                   
                </div>
              
                <button type="button" class="btn btn-info" id="changeCustomerBtn" @click="showCustomerOption()">Thay đổi</button>
                </div>
                </div>
               </div>
                </div>

                <span for="address" class="col-form-label text-info">Người nhận:</span>

                 <div class="row">
                        <label for="salesman_name" class="col-form-label col-md-3">Họ và tên:</label>
                        <span id="salesman_name" class="font-weight-bold col-md-9">{{ agency.salesman.name }}</span>
                </div>
                <div class="row">
                        <label for="role" class="col-form-label col-md-3">Chức vụ:</label>
                        <span id="role" class="font-weight-bold col-md-9">Nhân viên kinh doanh</span>
                </div>
                <div class="form-group">
                  <label for="message-text" class="col-form-label">Số tiền:</label>
                  <div class="input-group">
                        
                        <input type="text" id="amount" class="form-control text-right" aria-label="Amount" min="1000" v-model="amount" @keyup="formatCurrency()">
                        <div class="input-group-append">
                          <span class="input-group-text">VNĐ</span>
                        </div>
                      </div>
                      <p><span>Bằng chữ: </span><strong>{{ amountString }}.</strong></p>
                </div>
                <div class="form-group">
                        <label for="message-text" class="col-form-label">Phương thức giao dịch:</label>
                        <select name="payment_method" id="payment_method" class="form-control" v-model="paymentMethod">
                            <option value="2">Tiền mặt</option>
                            <option value="1">Chuyển khoản</option>
                        </select>
                </div>
            </div>
            <div class="modal-body" v-else>
                <span>Không tìm thấy dữ liệu hiển thị</span>
            </div>
            <div slot="modal-footer">
              <b-button variant="danger" @click="modalVisible=false">Hủy</b-button>
              <b-button variant="success" @click="updatePayment()" :disabled="isLoading">
               <v-icon v-if="isLoading" name="sync" spin></v-icon>
                {{confirmBtnContent}}</b-button>
            </div>
    </b-modal>
</template>

<script>
import { alerts, convertCurrencyToText, $ } from "../../utils";
import { event } from "../../utils";
import { http } from "@/services";
export default {
  data() {
    return {
      confirmBtnContent: "Xác nhận",
      isLoading: false,
      customerOptionVisibility: false,
      modalVisible: false,
      created: false,
      amount: "",
      amountString: "",
      paymentMethod: 2
    };
  },

  props: {
    agency: {
      type: Object,
      default: null
    }
  },
  watch: {
    modalVisible: function($oldValue, $newValue) {
      if ($newValue) {
        this.resetModuleState();
      }
    }
  },
  created() {
    //reset amount to empty
    // this.$on('showPaymentModal',this.showModal);
    //  console.log('created');
  },
  mounted() {
    // this.$on('show-modal',this.showModal);
  },
  methods: {
    showCustomerOption() {
      this.showCustomerOption != showCustomerOption;
    },
    hideModal() {
      this.modalVisible = false;
    },
    showModal() {
      this.modalVisible = true;
    },
    updatePayment() {
      if (!isNaN(this.amount)) {
        alerts.error("Vui lòng nhập số tiền!");
        return false;
      }
      this.isLoading = true;
      this.confirmBtnContent = "Đang xử  lý";
      http.post(
        "payment/store",
        {
          agency_id: this.agency.id,
          amount: this.amount,
          payment_method: this.paymentMethod,
          customer_id: this.agency.owner.id
        },
        response => {
          //return response;
          if (response.data.status) {
            alerts.success(response.data.msg);
          } else {
            alerts.warning(response.data.msg);
          }
          this.hideModal();
        },
        error => {
          alerts.error(error.response.statusText);
          this.resetModuleState();
        }
      );
    },
    formatCurrency() {
      this.amount = this.comma(this.amount);
      let int_amount = this.amount.replace(/,/, "");
      console.log(int_amount);
      this.amountString = convertCurrencyToText.convert(
        int_amount.replace(/,/, ""),
        "đồng"
      );
    },
    resetModuleState() {
      this.amount = "";
      this.isLoading = false;
      this.confirmBtnContent = "Xác nhận";
    }
  },
  computed: {
    fullAdress() {
      if (
        this.agency.province !== null &&
        (this.agency.district !== null) & (this.agency.ward !== null)
      ) {
        return (
          this.agency.address +
          " , " +
          this.agency.ward.name +
          " , " +
          this.agency.district.name +
          " , " +
          this.agency.province.name
        );
      }
      return this.agency.address;
    },
    formattedAmount() {
      return this.comma(this.amount);
    }
  }
};
</script>

<style>
</style>
